// ExamplePlugin.h : main header file for the plugin
//

#ifndef EXAMPLEPLUGIN_H
#define EXAMPLEPLUGIN_H

#include "TSIPluginInterface.h"

/*
 * This class implements a plugin by deriving it from the generic PluginInterface
 */
class ExamplePlugin : public TSIPluginInterface
{
public:
	
	PLUGIN_ACCESS ExamplePlugin();
	PLUGIN_ACCESS ~ExamplePlugin();

	PLUGIN_ACCESS bool initPlugin();
	PLUGIN_ACCESS bool executePreRun(uint16_t port = 0);
	PLUGIN_ACCESS bool executeTimePoint();
	PLUGIN_ACCESS bool executePostRun();
	
protected:
	int stepCounter, nChannels;
};

// To avoid C++ name mangling problems, we need to bootstrap access of plugin via C functions
//
extern "C" {
	PLUGIN_ACCESS TSIPluginInterface *createPlugin();
	PLUGIN_ACCESS const char *getPluginName();
	PLUGIN_ACCESS const char *getPluginDescription();
	PLUGIN_ACCESS const char *getAuthor();
	PLUGIN_ACCESS const char *getHelpFile();
	PLUGIN_ACCESS const char *getPluginVersion();
}


#endif // EXAMPLEPLUGIN_H
